<?php

namespace Modules\Post\Providers;

use Illuminate\Support\ServiceProvider;
use Illuminate\Support\Facades\Blade;
use Livewire\Livewire;
use Illuminate\Support\Facades\Gate;

class ModuleServiceProvider extends ServiceProvider
{
    protected string $moduleName = 'Post';

    public function register()
    {
        $this->app->register(RouteServiceProvider::class);
    }

    public function boot()
    {
        $this->registerViews();
        $this->registerLivewireViews();
        $this->registerMigrations();
        $this->registerConfig();
        $this->registerComponent();
        $this->registerLivewire();
    }

     protected function registerPolicies()
    {
        Gate::policy(\Modules\Post\Models\Post::class, \Modules\Post\Policies\PostPolicy::class);
    }

    protected function registerViews()
    {
        $moduleViewsPath = __DIR__ . '/../Views';
        $this->loadViewsFrom(
            $moduleViewsPath,
            strtolower($this->moduleName)
        );
    }

    protected function registerLivewireViews()
    {
        $moduleViewsPath = __DIR__ . '/../Views/livewire';
        $this->loadViewsFrom(
            $moduleViewsPath,
            strtolower($this->moduleName)
        );
    }

    protected function registerMigrations()
    {
        $this->loadMigrationsFrom(
            app_path('Modules/' . $this->moduleName . '/Database/Migrations')
        );
    }

    protected function registerConfig()
    {
        $path = app_path('Modules/' . $this->moduleName . '/Config/config.php');
        $this->mergeConfigFrom(
            $path,
            strtolower($this->moduleName)
        );
    }

    protected function registerLivewire()
    {
        Livewire::component('posts.list', \Modules\Post\Http\Livewire\PostsList::class);
        Livewire::component('post.card', \Modules\Post\Http\Livewire\PostCard::class);
        Livewire::component('post.form', \Modules\Post\Http\Livewire\PostUpdate::class);
    }

    protected function registerComponent()
    {
        //Blade::component('<name>', \Modules\<NAME>\Http\Components\<NAME>::class);
    }
}